
#include "flash.h"


// The Flash polling routine checks the Flash response
// Returns when the program or erase operation is complete
int FlashPolling(void)
{
    volatile unsigned char * p;
    volatile unsigned char toggle_bit, save_bit;
    unsigned char data;
    int i;
    int loop, null;

    p = (volatile unsigned char * ) 0x30000000;

    save_bit = *p;
    save_bit = save_bit & 0x40;
    //putnum (save_bit);


    for (;;)
    {
        toggle_bit = *p;
        //putnum (toggle_bit);

        toggle_bit = toggle_bit & 0x40;
        //putnum (toggle_bit);
        //print ("\r\n");

        if (save_bit == toggle_bit) 
            return ;
        save_bit = toggle_bit;
    }

    return null;

}

// The Flash write routine generate the writing timing to the Flash
int FlashWrite(unsigned long address, unsigned char data) 
{
    volatile unsigned char * p;
    int i;
    int loop, null;

    p = (volatile unsigned char * ) address;
    * p = data;

    null = 0;
    // Delay for some time before the next write
    for ( loop = 1; loop < 5; loop ++)
    {
        null = null + data;
    }

    return null;
}


// The Program routine program 1 byte to the specified address
void FlashProgram (unsigned long address, unsigned char data)
{

    FlashWrite(0x30005555, 0xAA);
    FlashWrite(0x30002AAA, 0x55);
    FlashWrite(0x30005555, 0xA0);
    FlashWrite(address, data);

    FlashPolling();
}

// Chip Erase 6 cycles 
// 5555 AA 2AAA 55 5555 80 5555 AA 2AAA 55 5555 10

void FlashErase (void)
{
    FlashWrite(0x30005555, 0xAA);
    FlashWrite(0x30002AAA, 0x55);
    FlashWrite(0x30005555, 0x80);
    FlashWrite(0x30005555, 0xAA);
    FlashWrite(0x30002AAA, 0x55);
    FlashWrite(0x30005555, 0x10);

    FlashPolling();
}

